#ifndef _UTIL_H_
#define _UTIL_H_

#include "common.h"

uint64_t x_to_u64(const char* p_hex);
uint8_t* x_to_u8_buffer(const char* p_hex);

int read_file(const char* p_file_path, uint8_t* p_data, uint64_t size);
int write_file(const char* p_file_path, uint8_t* p_data, uint64_t size);
int get_file_size(const char* p_file_path, uint64_t* p_size);
int mmap_file(const char* p_file_path, uint8_t** pp_data, uint64_t* p_size);
int unmmap_file(uint8_t* p_data, uint64_t size);

int hmac_sha1(const uint8_t* p_data, uint64_t size, const uint8_t* p_key, uint32_t key_length, uint8_t output[20]);

#endif /* !_UTIL_H_ */
